/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-09-03 14:20
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;

/* #define int ll */

template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const ll MAXN = 2e5 + 5;
const ll INF = 1LL << 60;

// greatest value that is 1
ll binsearch(ll l, ll r, function<bool(ll)> pred){
  swap(l, r);
  for(ll m = r; m != l; m = (l + r + 1) / 2)
    if(pred(m)) l = m; else r = m;
  return l;
}

ll N;
vector<ll> a, d;
vector<tuple<int, int, ll>> m;

bool pred(int limit){

    int id = 0;
    priority_queue<pair<int,ll>> pq;
    // pq stores (-to, people) for all carriages whose 'from' value <= current spaceid

    R(spaceid, N){
        for(; id < ssize(m); id++){
            auto [from, to, p] = m[id];
            if(from != spaceid) break;
            pq.emplace(-to, p);
        }
        ll sp = limit;
        while(ssize(pq) > 0){
            auto [to, p] = pq.top();
            pq.pop();
            if(p <= sp)
                sp -= p;
            else{
                pq.emplace(to, p - sp); // p -= sp
                break; // sp = 0;
            }
        }
        if( ssize(pq) > 0 and -pq.top().first <= spaceid )
            return 0;
    }

    return 1;
}


void solve(){
    // Code goes here ...
    cin >> N;
    a = vector<ll>(MAXN);
    d = vector<ll>(MAXN);

    R(i, N) cin >> a[i];
    R(i, N) cin >> d[i];

    R(i, N){
        int toleft = max(0LL, i - d[i]);
        int toright = min(N - 1, i + d[i]);
        m.emplace_back(toleft, toright, a[i]);
        /* fprintf(stderr, "%lld people from %d to %d\n", a[i], toleft, toright); */
    }

    R::sort(m);

    ll res = binsearch(0, 1e9, pred);

    cout << res << endl;
}


// =============== Main section ===============
signed main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    solve();

    return 0;
}
        
